import pencilFlow from '@ray-js/pencil-flow';

const { Shape } = pencilFlow;

const OFF_LIGHT_COLOR = '#e2e2e2';
const LINE_COLOR = "#C8C8C8"
const offsetDistance = 14; // 两个相邻图形的间隙

class Line extends Shape {
  constructor(data) {
    super();
    this.data = data;
  }

  draw() {
    this.clear();
    const { data: _data } = this;
    if (!_data) {
      return;
    }
    const {
      y,
      idx,
      endX,
      col,
      radius,
      isEvenRow,
      lightNum
    } = _data;
    const ctx = this;
    if ((idx === 0 || idx % col < col - 1) && lightNum !== idx + 1) {
      if (isEvenRow) {
        ctx.beginPath();
        ctx.strokeStyle(LINE_COLOR);
        ctx.lineWidth(2);
        ctx.moveTo(endX + radius, y)
        ctx.lineTo(endX + radius + offsetDistance, y)
      } else {
        ctx.beginPath();
        ctx.strokeStyle(LINE_COLOR);
        ctx.lineWidth(2);
        ctx.moveTo(endX - radius, y)
        ctx.lineTo(endX - (radius + offsetDistance), y)
      }
    }
    if ((idx + 1) / col % 2 === 1 && lightNum !== idx + 1) {
      ctx.beginPath();
      ctx.strokeStyle(LINE_COLOR);
      ctx.beginPath();
      ctx.lineWidth(2);
      const arcRadius = radius * 2.5 / 2;
      ctx.arc(
        endX + radius,
        y + radius * 2.5 / 2,
        arcRadius,
        Math.PI * 1.5,
        Math.PI * 0.5
      );
    }
    if ((idx + 1) / col % 2 === 0 && lightNum !== idx + 1) {
      ctx.beginPath();
      ctx.strokeStyle(LINE_COLOR);
      ctx.beginPath();
      ctx.lineWidth(2);
      const arcRadius = radius * 2.5 / 2;
      ctx.arc(
        endX - radius,
        y + radius * 2.5 / 2,
        arcRadius,
        Math.PI * 0.5,
        Math.PI * 1.5
      );
    }
    ctx.stroke();
  }
}

export default Line;