import pencilFlow from '@ray-js/pencil-flow';

const { Shape } = pencilFlow;

const OFF_LIGHT_COLOR = '#e2e2e2';
const LINE_COLOR = "#C8C8C8"
const offsetDistance = 14; // 两个相邻图形的间隙

class Round extends Shape {
  constructor(data) {
    super();
    this.data = data;
  }

  draw() {
    this.clear();
    const { data: _data } = this;
    if (!_data) {
      return;
    }
    const {
      x,
      y,
      idx,
      endX,
      col,
      color = 'red',
      radius,
      onOff = true, // 开关
    } = _data;
    const ctx = this;
    ctx.beginPath();
    let innerStrokeColor = color;
    ctx.fillStyle(onOff ? innerStrokeColor : OFF_LIGHT_COLOR);
    ctx.arc(x, y, radius, 0, Math.PI * 2);
    // 填充圆形
    ctx.fill();
    ctx.stroke();
  }
}

export default Round;
